// Generated by CoffeeScript 1.10.0
var NodeClient, Promise, XhrClient, newError, request,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

request = require('request');

Promise = require('broken');

XhrClient = require('./xhr');

newError = require('../utils').newError;

module.exports = NodeClient = (function(superClass) {
  extend(NodeClient, superClass);

  function NodeClient(opts) {
    if (opts == null) {
      opts = {};
    }
    if (!(this instanceof NodeClient)) {
      return new NodeClient(opts);
    }
    this.key = opts.key, this.debug = opts.debug;
    if (opts.endpoint) {
      this.setEndpoint(opts.endpoint);
    }
  }

  NodeClient.prototype.request = function(blueprint, data, key) {
    var opts;
    if (key == null) {
      key = this.getKey();
    }
    opts = {
      url: this.getUrl(blueprint.url, data, key),
      method: blueprint.method
    };
    if ((opts.method === 'POST') || (opts.method === 'PATCH')) {
      opts.json = data;
    } else {
      opts.json = true;
    }
    if (this.debug) {
      console.log('--REQUEST--');
      console.log(opts);
    }
    return new Promise((function(_this) {
      return function(resolve, reject) {
        return request(opts, function(err, res) {
          var ref;
          if (res != null) {
            if (_this.debug) {
              console.log('--RESPONSE--');
              console.log(res.toJSON());
            }
            res.status = res.statusCode;
            res.data = res.body;
          }
          if ((err != null) || (res.status > 308) || (((ref = res.data) != null ? ref.error : void 0) != null)) {
            err = newError(opts, res);
            if (_this.debug) {
              console.log('ERROR:', err);
            }
            return reject(err);
          }
          return resolve({
            url: opts.url,
            req: opts,
            res: res,
            data: res.data,
            responseText: res.data,
            status: res.status,
            statusText: res.statusText,
            headers: res.headers
          });
        });
      };
    })(this));
  };

  return NodeClient;

})(XhrClient);

//# sourceMappingURL=node.js.map
